"use strict";
/******************************************************************
 MIT License http://www.opensource.org/licenses/mit-license.php
 Author Mora <qiuzhongleiabc@126.com> (https://github.com/qiu8310)
*******************************************************************/
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var autocomplete_1 = require("../autocomplete");
var dev_1 = require("../dev");
var root = path.resolve(__dirname, 'fixtures', 'custom');
var fixture = function (key) { return path.resolve(root, key); };
var notEvent = function (attr) { return true; };
// const notEvent = (attr: ComponentAttr) => !attr.name.startsWith('bind') && !attr.name.startsWith('catch')
var WxmlConfig = {
    id: 'wxml',
    baseAttrs: [
        { name: 'id' },
        { name: 'class' },
        { name: 'style', desc: ['组件的内联样式'] },
        { name: 'hidden', desc: ['组件是否隐藏'] },
    ],
    event: {
        prefixes: ['bind:', 'catch:'],
        modifiers: [],
        attrs: [
            { name: 'touchstart' },
            { name: 'touchmove' },
            { name: 'touchcancel' },
            { name: 'touchend' },
            { name: 'tap' },
            { name: 'longpress', since: '1.5.0' },
            { name: 'longtap' },
            { name: 'transitionend' },
            { name: 'animationstart' },
            { name: 'animationiteration' },
            { name: 'animationend' },
        ],
    },
    custom: {
        'wx:': {
            modifiers: [],
            attrs: [
                { name: 'if', addBrace: true },
                { name: 'elif', addBrace: true },
                { name: 'else', boolean: true },
                { name: 'for', addBrace: true },
                { name: 'key' },
                { name: 'for-item' },
                { name: 'for-index' },
            ],
        },
    },
    components: [],
};
describe('autocompleteTagName', function () {
    test('should list all native tags', function () { return __awaiter(void 0, void 0, void 0, function () {
        var tags;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagName(WxmlConfig)];
                case 1:
                    tags = _a.sent();
                    expect(tags.natives.length).toEqual(dev_1.components.length);
                    expect(tags.customs.length).toEqual(0);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should include local tags', function () { return __awaiter(void 0, void 0, void 0, function () {
        var tags;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagName(WxmlConfig, { filename: fixture('using-comp.js') })];
                case 1:
                    tags = _a.sent();
                    expect(tags.customs.length).toEqual(3);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe('autocompleteTagAttr', function () {
    test('should include basic attrs and all native attrs', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr, c;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('text', {}, WxmlConfig)];
                case 1:
                    attr = _a.sent();
                    c = dev_1.components.find(function (i) { return i.name === 'text'; });
                    // expect(attr.basics.length).toEqual(BASE_ATTRS.length)
                    expect(attr.natives.length).toEqual(c.attrs && c.attrs.length);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should list all native exclude already exists', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr, c;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('text', { id: '1', space: '2' }, WxmlConfig)];
                case 1:
                    attr = _a.sent();
                    c = dev_1.components.find(function (i) { return i.name === 'text'; });
                    expect(attr.basics.length).toEqual(WxmlConfig.baseAttrs.length - 1);
                    expect(attr.natives.length).toEqual(c.attrs && c.attrs.length - 1);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should list all custom attrs', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('attr', {}, WxmlConfig, { filename: fixture('attr-page.json') })];
                case 1:
                    attr = _a.sent();
                    expect(attr.basics.length).toEqual(WxmlConfig.baseAttrs.length);
                    expect(attr.natives.length).toEqual(2);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should list all custom exclude already exists', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('attr', { foo: '1' }, WxmlConfig, { filename: fixture('attr-page.json') })];
                case 1:
                    attr = _a.sent();
                    expect(attr.natives.length).toEqual(1);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should list all attrs include subAttrs', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('picker', {}, WxmlConfig)];
                case 1:
                    attr = _a.sent();
                    expect(attr.natives.length).toBeGreaterThan(4);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should list specified subAttrs', function () { return __awaiter(void 0, void 0, void 0, function () {
        var c, mode, sub, attr1, attr2;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    c = dev_1.components.find(function (i) { return i.name === 'picker'; });
                    mode = c.attrs.find(function (a) { return a.name === 'mode'; });
                    if (!mode.subAttrs) return [3 /*break*/, 3];
                    sub = mode.subAttrs.find(function (s) { return s.equal === 'region'; }).attrs.filter(notEvent);
                    return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('picker', { mode: 'region' }, WxmlConfig)];
                case 1:
                    attr1 = _b.sent();
                    expect(attr1.natives.length).toEqual(sub.length);
                    return [4 /*yield*/, autocomplete_1.autocompleteTagAttr('picker', (_a = { mode: 'region' }, _a[sub[0].name] = '1', _a), WxmlConfig)];
                case 2:
                    attr2 = _b.sent();
                    expect(attr2.natives.length).toEqual(sub.length - 1);
                    return [3 /*break*/, 4];
                case 3: throw new Error('not subAttrs');
                case 4: return [2 /*return*/];
            }
        });
    }); });
});
describe('autocompleteSpecialTagAttr', function () {
    test('should autocomplete wx', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('wx:', 'view', {}, WxmlConfig)];
                case 1:
                    attr = _a.sent();
                    expect(attr.natives.length).toEqual(WxmlConfig.custom['wx:'].attrs.length);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should autocomplete bind/catch', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr1, attr2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('bind:', 'view', {}, WxmlConfig)];
                case 1:
                    attr1 = _a.sent();
                    expect(attr1.natives.length).toEqual(WxmlConfig.event.attrs.length);
                    return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('catch:', 'view', {}, WxmlConfig)];
                case 2:
                    attr2 = _a.sent();
                    expect(attr2.natives.length).toEqual(WxmlConfig.event.attrs.length);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should autocomplete bind/catch exclude exists', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('bind:', 'view', { 'bind:tap': true, 'bind:longtap': '1' }, WxmlConfig)];
                case 1:
                    attr = _a.sent();
                    expect(attr.natives.length).toEqual(WxmlConfig.event.attrs.length - 2);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should autocomplete bind/catch include native event', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('bind:', 'slider', {}, WxmlConfig)];
                case 1:
                    attr1 = _a.sent();
                    expect(attr1.customs.length).toBe(0);
                    expect(attr1.natives.length).toBeGreaterThan(0);
                    return [2 /*return*/];
            }
        });
    }); });
    test('should autocomplete bind/catch include custom native event', function () { return __awaiter(void 0, void 0, void 0, function () {
        var attr1, attr2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('bind:', 'attr', {}, WxmlConfig, {
                        filename: fixture('attr-page.json'),
                    })];
                case 1:
                    attr1 = _a.sent();
                    expect(attr1.customs.length).toEqual(0);
                    return [4 /*yield*/, autocomplete_1.autocompleteSpecialTagAttr('bind:', 'attr', { bindclick: true }, WxmlConfig, {
                            filename: fixture('attr-page.json'),
                        })];
                case 2:
                    attr2 = _a.sent();
                    expect(attr2.customs.length).toEqual(0);
                    return [2 /*return*/];
            }
        });
    }); });
});
