/******************************************************************
 MIT License http://www.opensource.org/licenses/mit-license.php
 Author Mora <qiuzhongleiabc@126.com> (https://github.com/qiu8310)
*******************************************************************/
import { TagItem } from '.';
import { CustomOptions } from './custom';
import { CustomAttr, LanguageConfig } from './dev/';
interface TagAttrItem {
    attr: CustomAttr;
    markdown: string;
}
/**
 * 自动补全支持的所有的 tag
 * @param {CustomOptions} co 用于解析自定义组件的配置
 */
export declare function autoApiName(lc: LanguageConfig, co?: CustomOptions): Promise<{
    customs: TagItem[];
    natives: TagItem[];
}>;
/**
 * 自动补全 Api 上的属性
 *
 * @export
 * @param {string} tagName 当前 tag 的名称
 * @param {{[key: string]: string}} attrs 当前已经写了的属性的集合
 * @param {CustomOptions} co 用于解析自定义组件的配置
 */
export declare function autoApiAttr(tagName: string, tagAttrs: {
    [key: string]: string | boolean;
}, lc: LanguageConfig, co?: CustomOptions): Promise<{
    natives: TagAttrItem[];
}>;
export {};
