"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/******************************************************************
 MIT License http://www.opensource.org/licenses/mit-license.php
 Author Mora <qiuzhongleiabc@126.com> (https://github.com/qiu8310)
*******************************************************************/
var ConditionalCacheableFile_1 = require("../ConditionalCacheableFile");
var os = require("os");
var path = require("path");
var fs = require("fs-extra");
var delay_1 = require("mora-common/util/delay");
var file;
beforeAll(function () { return (file = path.join(os.tmpdir(), 'test.txt')); });
afterEach(function () { return fs.existsSync(file) && fs.removeSync(file); });
describe.skip('getFilePath', function () {
    test('should get exists file content', function () { return __awaiter(void 0, void 0, void 0, function () {
        var f, c1, c2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.writeFileSync(file, 'abc');
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () { return file; });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    c1 = _a.sent();
                    expect(f.cached).toEqual(false);
                    expect(c1 && c1.toString()).toEqual('abc');
                    return [4 /*yield*/, f.getContent()];
                case 2:
                    c2 = _a.sent();
                    expect(f.cached).toEqual(true);
                    expect(c2 && c2.toString()).toEqual('abc');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should retry get file function when file first was cached and then removed', function () { return __awaiter(void 0, void 0, void 0, function () {
        var c, f, c1, c2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.writeFileSync(file, 'abc');
                    c = 0;
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () {
                        c++;
                        return c > 1 ? undefined : file;
                    });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    c1 = _a.sent();
                    expect(f.cached).toEqual(false);
                    expect(f.filename).toEqual(file);
                    expect(c1 && c1.toString()).toEqual('abc');
                    fs.unlinkSync(file);
                    return [4 /*yield*/, f.getContent()];
                case 2:
                    c2 = _a.sent();
                    expect(f.cached).toEqual(false);
                    expect(c2).toBeUndefined();
                    expect(c).toEqual(2);
                    return [2 /*return*/];
            }
        });
    }); });
    test('throw when file changed to directory', function () { return __awaiter(void 0, void 0, void 0, function () {
        var f, c, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.writeFileSync(file, 'abc');
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () { return file; });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    _a.sent();
                    fs.removeSync(file);
                    delay_1.sleep(1000);
                    fs.mkdirpSync(file);
                    c = 1;
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, f.getContent()];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 4:
                    e_1 = _a.sent();
                    c++;
                    return [3 /*break*/, 5];
                case 5:
                    expect(c).toEqual(2);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe.skip('parseFileContent', function () {
    test('should return undefined when file is not exists', function () { return __awaiter(void 0, void 0, void 0, function () {
        var f, c;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () { return undefined; }, function (filename, buf) { return 'abc'; });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    c = _a.sent();
                    expect(c).toBeUndefined();
                    return [2 /*return*/];
            }
        });
    }); });
    test('should return parsed content', function () { return __awaiter(void 0, void 0, void 0, function () {
        var f, c;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.writeFileSync(file, 'abc');
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () { return file; }, function (filename, buf) { return buf.toString() + buf.toString(); });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    c = _a.sent();
                    expect(c).toEqual('abcabc');
                    return [2 /*return*/];
            }
        });
    }); });
    test('should cached parsed content', function () { return __awaiter(void 0, void 0, void 0, function () {
        var count, f, c1, c2, c3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.writeFileSync(file, 'abc');
                    count = 0;
                    f = new ConditionalCacheableFile_1.ConditionalCacheableFile(function () { return file; }, function (filename, buf) {
                        count++;
                        return buf.toString() + buf.toString();
                    });
                    return [4 /*yield*/, f.getContent()];
                case 1:
                    c1 = _a.sent();
                    return [4 /*yield*/, f.getContent()];
                case 2:
                    c2 = _a.sent();
                    return [4 /*yield*/, f.getContent()];
                case 3:
                    c3 = _a.sent();
                    expect(c1).toEqual('abcabc');
                    expect(c2).toEqual('abcabc');
                    expect(c3).toEqual('abcabc');
                    expect(count).toEqual(1);
                    return [2 /*return*/];
            }
        });
    }); });
});
